/*
0 15 281361
1 50 281361
2 1303 281361
3 50314433 281361
4 403540 281361
5 17427575 281361
6 356850 281361
7 -1965882620 281361
*/

import java.io.File;
import java.util.HashSet;
import java.util.Scanner;

public class HashDemo {

	private static class MyString {
		static int numEquals, numHashCode;
		static int mode;
		String s;

		MyString(String s) { this.s = s; }

		static void resetCounts() { numEquals=numHashCode=0; }

		public boolean equals(Object other) {
			if (!(other instanceof MyString)) return false;
			numEquals++;
		return s.equals(((MyString)other).s);
		}

		public int hashCode() {
			numHashCode++;
			if (mode==0) {
				int c=0;
				for(int i=0;i<s.length();i++)
					c=37*c+s.charAt(i);
				return c;
			} else if (mode==1) {
				int c=0;
				for(int i=0;i<s.length();i++)
					c=39*c+s.charAt(i);
				return c;
			} else if (mode==2) {
				int c=0;
				for(int i=0;i<s.length();i++)
					c=36*c+s.charAt(i);
				return c;
			} else if (mode==3) {
				int c=0;
				for(int i=0;i<s.length();i++)
					c=c+s.charAt(i);
				return c;
			} else if (mode==4) {
				int c=0;
				for(int i=0;i<8 && i<s.length();i++)
					c=37*c+s.charAt(i);
				return c;
			} else if (mode==5) {
				int c=0;
				for(int i=0;i<4 && i<s.length();i++)
					c=37*c+s.charAt(i);
				return c;
			} else if (mode==6) {
				int[] arr={0,1,2,3,5,8,13,21};
				int c=0;
				for(int i=0;i<arr.length && arr[i]<s.length();i++)
					c=37*c+s.charAt(arr[i]);
				return c;
			} else if (mode==7) {
				int c=0;
				for(int i=0;i<1 && i<s.length();i++)
					c=37*c+s.charAt(i);
				return c;			} else throw new RuntimeException();
		}
	}

	public static void main(String[] args) {
		for(int i=0; i<8; i++) {
			MyString.mode=i;
			HashSet hash =  new HashSet();
			Scanner sc;
			try {
				sc = new Scanner(new File("english.txt"));
			} catch (Exception e) { throw new RuntimeException(e); }
			while(sc.hasNext()) {
				hash.add(new MyString(sc.next()));
			}
			System.out.println(i+" "+MyString.numEquals+" "+MyString.numHashCode);
			MyString.resetCounts();
		}
	}

}